<?php
namespace Compras\Logic\Fornecimento\Exception;

class FormaPagamento extends \Compras\Logic\Exception
{

    private $messageName;

    /**
     * Construtor.
     *
     * Recebe o nome da mensagem cadastrada no setforms.
     *
     * @param string $messageName
     * @param int $code
     * @param \Exception|null $previous
     */
    public function __construct($messageName, $code = 0, \Exception $previous = null)
    {
        parent::__construct($messageName, $code, $previous);
        $this->messageName = $messageName;
    }


    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }


    /**
     * O prazo de dias ja foi cadastrado
     * @static
     * @throws FormaPagamento
     */
    public static function prazoDiasExistente()
    {
        throw new self (tk_get_message_by_name("msg_prazo_dias_ja_cadastrado_forma_pgto"));
    }


    /**
     * O somatorio do percentual da forma de pagamento ultrapassa 100%
     * @static
     * @throws FormaPagamento
     */
    public static function excedeSomatorioPercentual()
    {
        throw new self (tk_get_message_by_name("msg_somatorio_percentual_forma_pgto"));
    }
    
}
