/*
@C:\WEB_411\Sql\End_Conv\Oracle\5920_FISSTPO_ARQUIVO_DIEFES.SQL
 raise_application_error(-20501, '' , True);
*/

CREATE OR REPLACE PROCEDURE ARQUIVO_DIEFES(
   P_CDIMPOSTO   IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA   IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA  IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_TIPODECLARA IN NOTAFISCAL.IDSTATUS%TYPE,
   P_FORMAPRES   IN NOTAFISCAL.IDSTATUS%TYPE,
   P_IDGIICMS    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_IDGESTOQ    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_NRSEQARQMAG IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
AS
   V_STLINHA      VARCHAR2(500);
   V_DTPOSINI     DATE;
   V_DTPOSFIM     DATE;
   V_QTDETOTAL    NUMBER;
   V_VRESTINIANT  NUMBER;
   V_DTESTINIANT  DATE;
   V_VRESTINIATUA NUMBER;
   V_DTESTINIATUA  DATE;
   V_VRESTFIMANT  NUMBER;
   V_DTESTFIMANT  DATE;
   V_VRESTFIMATUA NUMBER;
   V_DTESTFIMATUA  DATE;

BEGIN
   /* CABEALHO DO ARQUIVO*/
   V_STLINHA := '1'||'Arquivo de carga DIEF';
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('00', V_STLINHA, P_NRSEQARQMAG);
   /*REGISTRO PRINCIPAL*/
   V_STLINHA := '';
   V_QTDETOTAL := 0;
   FOR C_REGISTROP IN (SELECT VRNORMDEBI, VRESTOCRED, (SELECT NVL(MAX(DSITEMMAPR), ' ')
                                                       FROM ITMAPARECUP IT
                                                       WHERE IT.NRSEQUMAPAPU = MR.NRSEQUMAPAPU AND
                                                             IT.IDTIPOITMAPR = 'OC') AS DESCOC,
                              VROUTRDEBI, VRNORMCRED, VROUTRCRED, VRESTODEBI, VRDEDUCAO,
                              VRSLDCRANTE, M.VRTOTAIMPOS, VRSALDOCRED, VRDIFALIQU, S.VRIMPOSUB,
                              VRTTCTBLDEB, VRTTCTBLCRE,
                              M.DTVENCGUIA, M.CDRECEGUIA, M.VRRECEGUIA
                       FROM MAPAAPURAC M, MAPARECUP MR,
                            (SELECT SUM(VRIMPOSTONF) AS VRIMPOSUB
                             FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO I
                             WHERE M.CDEMPRESA    = P_CDEMPRESA     AND
                                   M.CDINSCESTA   = P_CDINSCESTA    AND
                                   M.CDIMPOSTO    = '80'            AND /*I.CDIMPOSTRIB*/
                                   M.DTINIPERIODO = P_DTINICIAL     AND
                                   M.DTFIMPERIODO = P_DTFINAL       AND
                                   M.NRSEQUMAPAPU = IP.NRSEQUMAPAPU AND
                                   IP.CDFISCALNF  = '1'             AND
                                   IP.IDIMPOSTONF = '1') S
                       WHERE M.CDEMPRESA    = P_CDEMPRESA  AND
                             M.CDINSCESTA   = P_CDINSCESTA AND
                             M.CDIMPOSTO    = P_CDIMPOSTO  AND
                             M.DTINIPERIODO = P_DTINICIAL  AND
                             M.DTFIMPERIODO = P_DTFINAL    AND
                             M.NRSEQUMAPAPU = MR.NRSEQUMAPAPU) LOOP
      V_STLINHA := SUBSTR('2' ||  /*Tipo de Registro*/
                          RPAD(REPLACE(REPLACE(REPLACE(REPLACE(P_CDINSCESTA,'.',''),',',''),'-',''),'/',''),9,' ') || /* Inscrio Estadual*/
                          TO_CHAR(P_DTINICIAL, 'MM')   || /*mes de referncia*/
                          TO_CHAR(P_DTINICIAL, 'YYYY') || /*ano de referncia*/
                          P_FORMAPRES || /* Forma de Apresentao */
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRNORMDEBI),'000000000.00'),'.','')) || /* Dbito do perodo*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VROUTRDEBI),'000000000.00'),'.','')) || /* Outros Dbitos*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRESTOCRED),'000000000.00'),'.','')) || /* Estorno de Crdito*/
                          RPAD(C_REGISTROP.DESCOC, 30, ' ') || /* Desc Outros Crditos*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VROUTRDEBI),'000000000.00'),'.','')) || /* Outros dbitos*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRNORMCRED),'000000000.00'),'.','')) || /* Crdito do Perodo*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VROUTRCRED),'000000000.00'),'.','')) || /**/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRESTODEBI),'000000000.00'),'.','')) || /**/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRDEDUCAO),'000000000.00'),'.','')) || /**/
                          RPAD(C_REGISTROP.DESCOC, 30, ' ') || /* Desc Outros Crditos*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VROUTRCRED),'000000000.00'),'.','')) || /* Outros Crditos*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRSLDCRANTE),'000000000.00'),'.','')) || /* Saldo Credor do perodo anterior*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRTOTAIMPOS),'000000000.00'),'.','')) || /* ICMS a Recolher*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRSALDOCRED),'000000000.00'),'.','')) || /* Saldo credor para o perodo seguinte*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRDIFALIQU),'000000000.00'),'.','')) || /* Diferencial de alquota*/
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRIMPOSUB,0)),'000000000.00'),'.','')) || /* Substituio Tributria*/
                          '00000000000'|| /* FUNDAP*/
                          '00000000000'|| /* Estimativa Supermercado*/
                          '00000000000'|| /* Estimativa Atacadista*/
                          RPAD(' ', 30, ' ') || /* Descrio Outro ICMS*/
                          '00000000000'|| /* Valor Outro ICMS*/
                          RPAD(' ', 30, ' ') || /* Descrio Outro ICMS*/
                          '00000000000'|| /* Valor Outro ICMS*/
                          RPAD(' ', 30, ' ') || /* Descrio Outro ICMS*/
                          '00000000000'|| /* Valor Outro ICMS*/
                          P_TIPODECLARA, 1, 388); /* Tipo de Declarao*/
      V_QTDETOTAL := V_QTDETOTAL + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('01', V_STLINHA, P_NRSEQARQMAG);
      /* REGISTRO DE CUSTOS E DESPESAS DO DIEF*/
      V_STLINHA := '';
      V_STLINHA := SUBSTR('3' ||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000', 1, 346);
      V_QTDETOTAL := V_QTDETOTAL + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('02', V_STLINHA, P_NRSEQARQMAG);
      /* VENCIMENTOS DA DIEF*/
      V_STLINHA := '';
      V_STLINHA := SUBSTR('4' ||
                          RPAD(RTRIM(NVL(C_REGISTROP.CDRECEGUIA, ' ')), 4, ' ') ||
                          NVL(TO_CHAR(C_REGISTROP.DTVENCGUIA, 'DDMMYYYY'), '00000000') ||
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRRECEGUIA,0)),'000000000.00'),'.',''))||
                          '0000' ||
                          '00000000' ||
                          '00000000000' ||
                          '0000' ||
                          '00000000' ||
                          '00000000000' ||
                          '0000' ||
                          '00000000' ||
                          '00000000000' ||
                          '0000' ||
                          '00000000' ||
                          '00000000000' ||
                          '0000' ||
                          '00000000' ||
                          '00000000000' ||
                          '0000' ||
                          '00000000' ||
                          '00000000000' ||
                          '0000' ||
                          '00000000' ||
                          '00000000000' , 1, 185);
      V_QTDETOTAL := V_QTDETOTAL + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('03', V_STLINHA, P_NRSEQARQMAG);
   END LOOP;
   /*RESUMO DE OPERAES DO DIEF*/
   FOR C_REGCFOP IN (SELECT SUBSTR(CDFISCOPERNF, 1, 3) AS CDFISCOPERNF, SUM(ROUND(VRCONTABILNF,2)) AS VRCONTABILNF,
                            SUM(DECODE(CDFISCALNF, '1', ROUND(VRBASECALCNF,2), 0)) AS VRBASECALC,
                            SUM(DECODE(CDFISCALNF, '1', ROUND(VRIMPOSTONF,2), 0)) AS VRIMPOSTO,
                            SUM(DECODE(CDFISCALNF, '2', ROUND(VRCONTABILNF,2), 0)) AS VRISENTO,
                            SUM(DECODE(CDFISCALNF, '3', ROUND(VRCONTABILNF,2), 0)) AS VROUTROS
                     FROM MAPAAPURAC M, IMPOSTONF I
                     WHERE M.CDEMPRESA    = P_CDEMPRESA  AND
                           M.CDINSCESTA   = P_CDINSCESTA AND
                           M.CDIMPOSTO    = P_CDIMPOSTO  AND
                           M.DTINIPERIODO = P_DTINICIAL  AND
                           M.DTFIMPERIODO = P_DTFINAL    AND
                           M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                     GROUP BY SUBSTR(CDFISCOPERNF, 1, 3)) LOOP
      V_STLINHA := SUBSTR('5' ||
                          SUBSTR(C_REGCFOP.CDFISCOPERNF,1,3) || '0' ||
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGCFOP.VRCONTABILNF),'000000000.00'),'.','')) ||
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGCFOP.VRBASECALC)  ,'000000000.00'),'.','')) ||
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGCFOP.VRIMPOSTO)   ,'000000000.00'),'.','')) ||
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGCFOP.VRISENTO)    ,'000000000.00'),'.','')) ||
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGCFOP.VROUTROS)    ,'000000000.00'),'.','')), 1, 61);
      V_QTDETOTAL := V_QTDETOTAL + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('04', V_STLINHA, P_NRSEQARQMAG);
   END LOOP;
   /* GI-ICMS */
   IF P_IDGIICMS = 'S' THEN
      V_STLINHA := '';
   END IF;
   /* ESTOQUE */
   IF P_IDGESTOQ = 'S' THEN
      /* POSIO DE ESTOQUE DO ANO ANTERIOR*/
      V_DTPOSINI := TO_DATE('01/01'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, -12), 'YYYY')); /* DATA INICIAL DO ANO ANTERIOR*/
      V_DTPOSFIM := TO_DATE('01/01'||TO_CHAR(P_DTINICIAL, 'YYYY'));
      SELECT SUM(I.VRTOTINVFISC)
       INTO V_VRESTINIANT
      FROM INVENTFISC I, PRODUTO P
         WHERE I.CDEMPRESA    = P_CDEMPRESA
           AND I.CDINSCESTA   = P_CDINSCESTA
           AND I.CDPRODUTO    = P.CDPRODUTO
           AND I.QTESTINVFISC <> 0
           AND I.DTINVEFISCAL = (SELECT MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= V_DTPOSINI
                                             AND V.CDEMPRESA = P_CDEMPRESA
                                             AND V.CDINSCESTA   = P_CDINSCESTA
                                             AND V.CDPRODUTO    = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0);

      SELECT SUM(I.VRTOTINVFISC)
       INTO V_VRESTFIMANT
      FROM INVENTFISC I, PRODUTO P
      WHERE I.CDEMPRESA   = P_CDEMPRESA
       AND I.CDINSCESTA   = P_CDINSCESTA
       AND I.CDPRODUTO    = P.CDPRODUTO
       AND I.QTESTINVFISC <> 0
       AND I.DTINVEFISCAL = (SELECT MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= V_DTPOSFIM
                                             AND V.CDEMPRESA = P_CDEMPRESA
                                             AND V.CDINSCESTA   = P_CDINSCESTA
                                             AND V.CDPRODUTO    = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0);


      /* POSIO DE ESTOQUE ATUAL*/
      V_DTPOSINI := TO_DATE('01/01'||TO_CHAR(P_DTINICIAL, 'YYYY')) + 1; /* DATA INICIAL DO ANO ANTERIOR*/
      V_DTPOSFIM := TO_DATE('01/01'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, 12), 'YYYY'));

      SELECT SUM(I.VRTOTINVFISC)
       INTO V_VRESTINIATUA
      FROM INVENTFISC I, PRODUTO P
         WHERE I.CDEMPRESA    = P_CDEMPRESA
           AND I.CDINSCESTA   = P_CDINSCESTA
           AND I.CDPRODUTO    = P.CDPRODUTO
           AND I.QTESTINVFISC <> 0
           AND I.DTINVEFISCAL = (SELECT MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= V_DTPOSINI
                                             AND V.CDEMPRESA = P_CDEMPRESA
                                             AND V.CDINSCESTA   = P_CDINSCESTA
                                             AND V.CDPRODUTO    = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0);

      SELECT SUM(I.VRTOTINVFISC)
      INTO V_VRESTFIMATUA
       FROM INVENTFISC I, PRODUTO P
         WHERE I.CDEMPRESA    = P_CDEMPRESA
           AND I.CDINSCESTA   = P_CDINSCESTA
           AND I.CDPRODUTO    = P.CDPRODUTO
           AND I.QTESTINVFISC <> 0
           AND I.DTINVEFISCAL = (SELECT MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= V_DTPOSFIM
                                             AND V.CDEMPRESA    = P_CDEMPRESA
                                             AND V.CDINSCESTA   = P_CDINSCESTA
                                             AND V.CDPRODUTO    = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0);

      V_STLINHA := 'N' ||
                   LTRIM(REPLACE(TO_CHAR(ABS(V_VRESTINIANT),'00000000.00'),'.',''))     ||
                   LTRIM(REPLACE(TO_CHAR(ABS(V_VRESTFIMANT),'00000000.00'),'.',''))     ||
                   LTRIM(REPLACE(TO_CHAR(ABS(V_VRESTINIATUA),'00000000.00'),'.',''))    ||
                   LTRIM(REPLACE(TO_CHAR(ABS(V_VRESTFIMATUA),'00000000.00'),'.',''));
      V_QTDETOTAL := V_QTDETOTAL + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('05', V_STLINHA, P_NRSEQARQMAG);
   END IF;
   /* REGISTRO FINAL*/
   IF P_TIPODECLARA = '0'THEN
      V_STLINHA := 'D' ||
                  LTRIM(TO_CHAR(V_QTDETOTAL + 2,'00000')) ||
                  LTRIM(TO_CHAR(V_QTDETOTAL,'00000')) ||
                  '00000' ||
                  '00000';
   ELSE
      V_STLINHA := 'D' ||
                  LTRIM(TO_CHAR(V_QTDETOTAL + 2,'00000')) ||
                  '00000' ||
                  LTRIM(TO_CHAR(V_QTDETOTAL,'00000')) ||
                  '00000';
   END IF;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('06', V_STLINHA, P_NRSEQARQMAG);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DIEFES','4.11.017'); END;
/
