IF EXISTS(SELECT
             NAME
          FROM
             SYSOBJECTS
          WHERE
             NAME = 'ATUALIZA_DADOS_EFETDIET' AND
             TYPE = 'TR')


  DROP TRIGGER ATUALIZA_DADOS_EFETDIET
  GO


CREATE TRIGGER ATUALIZA_DADOS_EFETDIET
ON EFETDIET
FOR UPDATE, INSERT, DELETE
AS

   DECLARE @V_DTINICIAL       DATETIME;
   DECLARE @V_DTFINAL         DATETIME;
   DECLARE @V_IDFECHDIAROP    VARCHAR(1);
   DECLARE @V_NEW_CDFILIAL    VARCHAR(4);
   DECLARE @V_OLD_CDFILIAL    VARCHAR(4);
   DECLARE @V_NEW_QTCOMEFETDIE  DATETIME;
   DECLARE @V_NEW_QTFUNEFETDIE  DATETIME;
   DECLARE @V_NEW_QTDOAEFETDIE  DATETIME;
   DECLARE @V_OLD_QTFUNEFETDIE  DATETIME;
   DECLARE @V_OLD_QTCOMEFETDIE  DATETIME;
   DECLARE @V_OLD_QTDOAEFETDIE  DATETIME;
   DECLARE @V_ID_COMANDO      VARCHAR(1);
   DECLARE @V_IDUTPADRROP     VARCHAR(1);
   DECLARE @V_IDUTPADRROPFIL  VARCHAR(1);
   DECLARE @V_DTEFETDIET      DATETIME;
   DECLARE @V_OLD_DTEFETDIET  DATETIME;

BEGIN
   SET @V_ID_COMANDO = 'N';

   DECLARE C_CURSOR_DATA CURSOR FOR
      SELECT
        'U' IDCOMANDO,
        DELETED.CDFILIAL,
        DELETED.QTCOMEFETDIE,
        DELETED.QTFUNEFETDIE,
        DELETED.QTDOAEFETDIE,
        INSERTED.CDFILIAL,
        INSERTED.QTCOMEFETDIE,
        INSERTED.QTFUNEFETDIE,
        INSERTED.QTDOAEFETDIE,
        INSERTED.DTEFETDIET,
        DELETED.DTEFETDIET
      FROM
          DELETED,
          INSERTED
      WHERE
         INSERTED.CDFILIAL  = DELETED.CDFILIAL

      UNION ALL

      SELECT
        'I' IDCOMANDO,
        NULL,NULL,NULL,NULL,
        INSERTED.CDFILIAL,
        INSERTED.QTCOMEFETDIE,
        INSERTED.QTFUNEFETDIE,
        INSERTED.QTDOAEFETDIE,
        INSERTED.DTEFETDIET,
        NULL
      FROM
        INSERTED
      WHERE
        0 = (SELECT COUNT(*) FROM DELETED)

      SELECT
        'D' IDCOMANDO,
        DELETED.CDFILIAL,
        DELETED.QTCOMEFETDIE,
        DELETED.QTFUNEFETDIE,
        DELETED.QTDOAEFETDIE,
        NULL, NULL, NULL, NULL, NULL,
        DELETED.DTEFETDIET
      FROM
        DELETED
      WHERE
        0 = (SELECT COUNT(*) FROM INSERTED);

   OPEN C_CURSOR_DATA;
   FETCH NEXT FROM C_CURSOR_DATA INTO @V_ID_COMANDO,
                                      @V_OLD_CDFILIAL,
                                      @V_OLD_QTFUNEFETDIE,
                                      @V_OLD_QTCOMEFETDIE,
                                      @V_OLD_QTDOAEFETDIE,
                                      @V_NEW_CDFILIAL,
                                      @V_NEW_QTCOMEFETDIE,
                                      @V_NEW_QTFUNEFETDIE,
                                      @V_NEW_QTDOAEFETDIE,
                                      @V_DTEFETDIET,
                                      @V_OLD_DTEFETDIET

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'U' BEGIN
         SELECT @V_IDUTPADRROP = IDUTPADRROP
         FROM PARAMGERAL G;

         SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
         FROM  PARFILIALROP
         WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

         IF @V_IDUTPADRROP = 'S' OR @V_IDUTPADRROPFIL = 'S' BEGIN
            SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                   @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
            FROM  PARFILIALROP
            WHERE CDFILIAL = 'P';
         END;

         IF  (@V_NEW_QTCOMEFETDIE <> @V_OLD_QTCOMEFETDIE)
         AND (@V_NEW_QTFUNEFETDIE <> @V_OLD_QTFUNEFETDIE)
         AND (@V_NEW_QTDOAEFETDIE <> @V_OLD_QTDOAEFETDIE)
         BEGIN
            SELECT @V_DTINICIAL = MAX(DTINIAPURACROP),
                   @V_DTFINAL   = MAX(DTFINAPURACROP)
            FROM APURACAOROP
            WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

            IF (ISNULL(@V_IDFECHDIAROP,'N') <> 'S') BEGIN

               IF (@V_DTEFETDIET < @V_DTFINAL)  AND (@V_DTEFETDIET < @V_DTINICIAL) BEGIN

                  UPDATE APURACAOROP
                  SET DTINIAPURACROP  = @V_DTEFETDIET
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;

            END
            ELSE BEGIN
               DELETE ROPFILIAL
               WHERE CDFILIAL     = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL)  AND
                     DTFILIALROP  >= @V_DTEFETDIET;

               IF (@V_DTEFETDIET< @V_DTINICIAL) BEGIN
                  UPDATE APURACAOROP
                  SET  DTINIAPURACROP  = @V_DTEFETDIET
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;

            END;
         END;
      END;

      IF @V_ID_COMANDO = 'I' BEGIN
         SELECT @V_IDUTPADRROP = IDUTPADRROP
         FROM PARAMGERAL G;

         SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
         FROM  PARFILIALROP
         WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

         IF @V_IDUTPADRROP = 'S' OR @V_IDUTPADRROPFIL = 'S' BEGIN
            SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                   @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
            FROM  PARFILIALROP
            WHERE CDFILIAL = 'P';
         END;

         SELECT @V_DTINICIAL = MAX(DTINIAPURACROP),
                   @V_DTFINAL   = MAX(DTFINAPURACROP)
            FROM APURACAOROP
            WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

            IF (ISNULL(@V_IDFECHDIAROP,'N') <> 'S') BEGIN

               IF (@V_DTEFETDIET < @V_DTFINAL)  AND (@V_DTEFETDIET < @V_DTINICIAL) BEGIN

                  UPDATE APURACAOROP
                  SET DTINIAPURACROP  = @V_DTEFETDIET
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;

            END
            ELSE BEGIN
               DELETE ROPFILIAL
               WHERE CDFILIAL     = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL)  AND
                     DTFILIALROP  >= @V_DTEFETDIET;

               IF (@V_DTEFETDIET< @V_DTINICIAL) BEGIN
                  UPDATE APURACAOROP
                  SET  DTINIAPURACROP  = @V_DTEFETDIET
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;

            END;
      END;

      IF @V_ID_COMANDO = 'D' BEGIN
         SELECT @V_IDUTPADRROP = IDUTPADRROP
         FROM PARAMGERAL G;

         SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
         FROM  PARFILIALROP
         WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

         IF @V_IDUTPADRROP = 'S' OR @V_IDUTPADRROPFIL = 'S' BEGIN
            SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                   @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
            FROM  PARFILIALROP
            WHERE CDFILIAL = 'P';
         END;

         SELECT @V_DTINICIAL = MAX(DTINIAPURACROP),
                   @V_DTFINAL   = MAX(DTFINAPURACROP)
            FROM APURACAOROP
            WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

            IF (ISNULL(@V_IDFECHDIAROP,'N') <> 'S') BEGIN

               IF (@V_OLD_DTEFETDIET < @V_DTFINAL)  AND (@V_OLD_DTEFETDIET < @V_DTINICIAL) BEGIN
                  UPDATE APURACAOROP
                  SET DTINIAPURACROP  = @V_OLD_DTEFETDIET
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;

            END
            ELSE BEGIN
               DELETE ROPFILIAL
               WHERE CDFILIAL     = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL)  AND
                     DTFILIALROP  >= @V_DTEFETDIET;

               IF (@V_OLD_DTEFETDIET< @V_DTINICIAL) BEGIN
                  UPDATE APURACAOROP
                  SET  DTINIAPURACROP  = @V_OLD_DTEFETDIET
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;
            END;
      END;

         FETCH NEXT FROM C_CURSOR_DATA INTO @V_ID_COMANDO,
                                      @V_OLD_CDFILIAL,
                                      @V_OLD_QTFUNEFETDIE,
                                      @V_OLD_QTCOMEFETDIE,
                                      @V_OLD_QTDOAEFETDIE,
                                      @V_NEW_CDFILIAL,
                                      @V_NEW_QTCOMEFETDIE,
                                      @V_NEW_QTFUNEFETDIE,
                                      @V_NEW_QTDOAEFETDIE,
                                      @V_DTEFETDIET,
                                      @V_OLD_DTEFETDIET

   END;
   CLOSE C_CURSOR_DATA;
   DEALLOCATE C_CURSOR_DATA;
END;

GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_DADOS_EFETDIET','5.11.000';
GO
